clear all
close all
clc
warning off all;

tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters

HOMEMATS = '.\data_complete\';
categories = {'doc','nondoc','image'};
NtrainingPerClass = 600;
Nclasses = length(categories);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
images = dir(fullfile(HOMEMATS, '*.jpg'));
images = {images(:).name};
Nimages = length(images);

for n = 1:Nimages
%    disp(n)
    system(['lbp.exe ', fullfile(HOMEMATS, images{n}), ' 256 ']);
end

docs = dir(fullfile(HOMEMATS, '*.txt'));
docs = {docs(:).name};
Ndocs = length(docs);
Nfeatures = 256;
F = zeros([Ndocs Nfeatures]);
C = zeros([Ndocs 1]);
idx = 1;

for n = 1:Ndocs
    g = load(fullfile(HOMEMATS, docs{n}));
    
    if(~isempty(g))
        F(idx,:) = g / sum(g);
        C(idx) = strmatch(docs{n}(1), categories);
        idx = idx + 1;
    end
end

fid = fopen('data.txt', 'w');
fprintf( fid, '%d\t%d\n', size(F,1), size(F,2));
for i = 1 : size(F,1)
    for j = 1 : size(F,2) - 1
        fprintf( fid, '%f\t', F(i,j));
    end
    fprintf( fid, '%f\n', F(i,size(F,2)));
end
fclose(fid);

fid2 = fopen('class.txt', 'w');
for i = 1 : size(C,1)
    fprintf( fid2, '%d\n', C(i));
end
fclose(fid2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Split training/test (train = index training samples, test = index test)
train = [];
for c = 1:Nclasses
    j = find(C==c);
    t = randperm(length(j));
    train = [train; j(t(1:NtrainingPerClass))];
end
test = setdiff(1:Ndocs, train)';

fid3 = fopen('training.txt', 'w');
fprintf( fid2, '%d\n', length(train));
for i = 1 : size(train,1)
    fprintf( fid2, '%d\n', train(i)-1);
end
fclose(fid3);

system('svm.exe');
Cm = load('tmp.txt')

figure
subplot(121)
imagesc(Cm); axis('square'); colorbar
subplot(122)
bar(diag(Cm))
title(mean(diag(Cm)))
axis('square')

toc